﻿using Syncfusion.SfDataGrid.XForms.DataPager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfDataGrid.XForms.Renderers;
using Syncfusion.Data;
using System.Reflection;

namespace DataGridDemo
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            dataGrid.GridStyle = new Style();

            string translate = "Items";
            GridSummaryRow summaryRow = new GridSummaryRow();
            summaryRow.Title = "Date : {CaptionSummary} " + translate;
            summaryRow.ShowSummaryInRow = true;
            summaryRow.SummaryColumns.Add(new GridSummaryColumn
            {
                Name = "CaptionSummary",
                CustomAggregate = new CustomAggregate(),
                MappingName = "Date",
                Format = "{Date}",
                SummaryType = Syncfusion.Data.SummaryType.Custom
            });
            dataGrid.CaptionSummaryRow = summaryRow;
        }
    }

    public class CustomAggregate : ISummaryAggregate
    {
        public CustomAggregate()
        {
        }
        public string Date { get; set; }
        public Action<System.Collections.IEnumerable, string, PropertyInfo> CalculateAggregateFunc()
        {
            return (items, property, pd) =>
            {
                var enumerableItems = items as IEnumerable<OrderInfo>;
                if (pd.Name == "Date")
                {
                    var value = (enumerableItems.First() as OrderInfo).Date;
                    var count = enumerableItems.Count().ToString();
                    this.Date = value.Day + "/" + value.Month + "/" + value.Year +" - "+count;
                }
            };
        }
    }

    public class Style : DataGridStyle
    {
        public override Color GetBorderColor()
        {
            return Color.Red;
        }
    }
}
